## mingw-w64-helics-3.6.1-2.src.tar.zst

=== CMakeLists.txt ===
# ~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~

cmake_minimum_required(VERSION 3.22...3.31)

# Install dependencies using vcpkg if VCPKG_ROOT is set and no CMake Toolchain file is given vcpkg
# installation on a system doesn't set VCPKG_ROOT, so setting it should be like an opt-in for users
option(HELICS_DISABLE_VCPKG "Force CMake to ignore VCPKG_ROOT even if it is set" OFF)
mark_as_advanced(HELICS_DISABLE_VCPKG)
if(DEFINED ENV{VCPKG_ROOT} AND NOT DEFINED CMAKE_TOOLCHAIN_FILE AND NOT HELICS_DISABLE_VCPKG)
    set(CMAKE_TOOLCHAIN_FILE "$ENV{VCPKG_ROOT}/scripts/buildsystems/vcpkg.cmake" CACHE STRING "")
endif()

message(STATUS "Generating with CMAKE version ${CMAKE_VERSION}")
project(HELICS VERSION 3.6.1)

# -----------------------------------------------------------------------------
# HELICS Version number
# -----------------------------------------------------------------------------
set(HELICS_VERSION_BUILD)
# use ISO date YYYY-MM-DD
set(HELICS_DATE "2025-02-24")

set(HELICS_VERSION_UNDERSCORE
    "${HELICS_VERSION_MAJOR}_${HELICS_VERSION_MINOR}_${HELICS_VERSION_PATCH}"
)
if(HELICS_VERSION_BUILD)
    set(HELICS_VERSION "${HELICS_VERSION}-${HELICS_VERSION_BUILD}")
    set(HELICS_VERSION_UNDERSCORE "${HELICS_VERSION_UNDERSCORE}-${HELICS_VERSION_BUILD}")
endif()

set(HELICS_COMPILER_VERSION
    "${CMAKE_GENERATOR} ${CMAKE_GENERATOR_PLATFORM} ${CMAKE_SYSTEM}:${CMAKE_CXX_COMPILER_ID}-${CMAKE_CXX_COMPILER_VERSION}"
)
message(STATUS "SYSTEM INFO -> ${HELICS_COMPILER_VERSION}")

# -----------------------------------------------------------------------------
# set the module path and include some common macros
# -----------------------------------------------------------------------------

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
    set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/config/cmake/"
                          "${PROJECT_SOURCE_DIR}/ThirdParty/cmake/"
    )
else()
    set(${PROJECT_NAME}_ORIGINAL_MODULE_PATH ${CMAKE_MODULE_PATH})
    set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/config/cmake/"
                          "${PROJECT_SOURCE_DIR}/ThirdParty/cmake/" ${CMAKE_MODULE_PATH}
    )

endif()

include(commonBuildPaths)

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
    set_property(GLOBAL PROPERTY USE_FOLDERS ON)
else()
    get_property(helics-use-folders GLOBAL PROPERTY USE_FOLDERS)
endif()

if(NOT HELICS_DISABLE_GIT_OPERATIONS)
    # generate a version description based on git tags
    include(version_describe)
    git_version_describe(${HELICS_SOURCE_DIR} HELICS_VERSION_DESCRIPTION)
endif()

if(HELICS_VERSION_DESCRIPTION)
    message(STATUS "helics version tag description is ${HELICS_VERSION_DESCRIPTION}")
    string(TIMESTAMP current_date "%Y-%m-%d")
    set(HELICS_VERSION_STRING "${HELICS_VERSION}-${HELICS_VERSION_DESCRIPTION} (${current_date})")
else()
    set(HELICS_VERSION_STRING "${HELICS_VERSION} (${HELICS_DATE})")
endif()

include(extraMacros)
include(CMakeDependentOption)
include(copy_key_files)
include(CTest)

option(
    HELICS_ENABLE_PYTHON_BUILD_SCRIPTS
    "HELICS build systems can use python to automatically generate some files.  This is not required but may be useful if you are a developer and frequently modifying some files"
    OFF
)
mark_as_advanced(HELICS_ENABLE_PYTHON_BUILD_SCRIPTS)

if(HELICS_ENABLE_PYTHON_BUILD_SCRIPTS)
    find_package(Python COMPONENTS Interpreter)
endif()

# allow BOOST library inclusion to be turned off completely; this option will disable the IPC core
option(HELICS_DISABLE_BOOST OFF "disable all references to the Boost C++ libraries")
mark_as_advanced(HELICS_DISABLE_BOOST)

# allow ASIO library inclusion to be turned off completely; this option will disable the UDP and TCP
# core as well as the timeout detection and real-time features of HELICS
option(HELICS_DISABLE_ASIO OFF "disable all references to the ASIO C++ libraries")
mark_as_advanced(HELICS_DISABLE_ASIO)

# we want to acknowledge this flag since it is standard CMake but it can cause issues in submodules
# so we need to set other variables
if(NOT DEFINED BUILD_SHARED_LIBS)
    set(BUILD_SHARED_LIBS OFF CACHE INTERNAL "")
endif()
if(BUILD_SHARED_LIBS)
    set(HELICS_BUILD_CXX_SHARED_LIB ON CACHE BOOL "")
    set(HELICS_DISABLE_C_SHARED_LIB OFF CACHE BOOL "")
    set(old_build_shared ON)
    # we need this to prevent submodules from building shared libs
    set(BUILD_SHARED_LIBS OFF CACHE BOOL "" FORCE)
endif()

cmake_dependent_option(
    HELICS_BUILD_TESTS "Enable the HELICS test executables to be built" OFF
    "BUILD_TESTING;CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME" OFF
)

cmake_dependent_option(
    HELICS_BUILD_EXAMPLES "Build HELICS examples" OFF "CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME"
    OFF
)

cmake_dependent_option(
    HELICS_BUILD_BENCHMARKS "Build HELICS Benchmarks" OFF
    "CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME" OFF
)

cmake_dependent_advanced_option(
    HELICS_WITH_CMAKE_PACKAGE "Generate and install cmake package files" ON
    "CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME" OFF
)

option(HELICS_BINARY_ONLY_INSTALL "only install the helics binary executables" OFF)
mark_as_advanced(HELICS_BINARY_ONLY_INSTALL)

# Install instructions for this target
if(HELICS_WITH_CMAKE_PACKAGE)
    set(HELICS_EXPORT_COMMAND EXPORT helics-targets)
else(HELICS_WITH_CMAKE_PACKAGE)
    set(HELICS_EXPORT_COMMAND)
endif(HELICS_WITH_CMAKE_PACKAGE)

option(HELICS_DISABLE_C_SHARED_LIB OFF "turn off building of the HELICS C shared library interface")
mark_as_advanced(HELICS_DISABLE_C_SHARED_LIB)

option(HELICS_BUILD_CXX_SHARED_LIB "build the shared libraries for the HELICS CXX interface" OFF)

cmake_dependent_advanced_option(
    HELICS_USE_POSITION_INDEPENDENT_CODE
    "Build the libraries with Position independent code Useful if only building the static library and it will be used later in a shared library"
    OFF
    "HELICS_DISABLE_C_SHARED_LIB;NOT HELICS_BUILD_CXX_SHARED_LIB"
    ON
)

cmake_dependent_option(
    HELICS_GENERATE_DOXYGEN_DOC "Generate HELICS Doxygen doc target" OFF
    "CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME" OFF
)

if(NOT HELICS_DISABLE_C_SHARED_LIB OR HELICS_BUILD_CXX_SHARED_LIB
   OR HELICS_USE_POSITION_INDEPENDENT_CODE
)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()

option(HELICS_ENABLE_LOGGING "enable normal, debug, and trace logging in HELICS" ON)

cmake_dependent_advanced_option(
    HELICS_ENABLE_TRACE_LOGGING "enable trace logging" ON "HELICS_ENABLE_LOGGING" ON
)
cmake_dependent_advanced_option(
    HELICS_ENABLE_DEBUG_LOGGING "enable debug logging" ON "HELICS_ENABLE_LOGGING" ON
)

include(commonBuildFlags)

# add a baseline library for underlying dependencies and flags
add_library(helics_base INTERFACE)

add_library(HELICS::compile_flags_target ALIAS compile_flags_target)
add_library(HELICS::build_flags_target ALIAS build_flags_target)

get_target_property(EXTRA_BUILD_FLAGS build_flags_target INTERFACE_COMPILE_OPTIONS)

# -------------------------------------------------------------
# add coverage target
# -------------------------------------------------------------

cmake_dependent_advanced_option(
    HELICS_TEST_CODE_COVERAGE "Build a target for testing code coverage" OFF "HELICS_BUILD_TESTS"
    OFF
)

if(HELICS_BUILD_TESTS AND HELICS_TEST_CODE_COVERAGE)
    if(CMAKE_BUILD_TYPE STREQUAL "Coverage")
        include(CodeCoverage)

        set(COVERAGE_EXCLUDES
            'usr/*'
            'dependencies/*'
            'ThirdParty/*'
            'tests/*'
            'interfaces/*'
            'examples/*'
            'benchmarks/*'
            'scripts/*'
        )
        setup_target_for_coverage(
            NAME helics_coverage # New target name
            EXECUTABLE CTest # Executable in PROJECT_BINARY_DIR
        )
    else()
        message(FATAL_ERROR "CMAKE_BUILD_TYPE must be set to Coverage for testing code coverage")
    endif()
endif()

if(HELICS_GENERATE_DOXYGEN_DOC)
    find_package(Doxygen)
    if(DOXYGEN_FOUND)

        show_variable(
            DOXYGEN_OUTPUT_DIR PATH "location to put Doxygen docs" "${HELICS_BINARY_DIR}/docs"
        )
        configure_file(${HELICS_SOURCE_DIR}/config/Doxyfile.in ${HELICS_BINARY_DIR}/Doxyfile @ONLY)
        add_custom_target(
            helics_doxygen
            ${DOXYGEN_EXECUTABLE} ${HELICS_BINARY_DIR}/Doxyfile
            WORKING_DIRECTORY ${DOXYGET_OUTPUT_DIR}
            COMMENT "Generating API documentation with Doxygen"
            VERBATIM
        )
        set_target_properties(helics_doxygen PROPERTIES FOLDER docs)
    endif(DOXYGEN_FOUND)
endif(HELICS_GENERATE_DOXYGEN_DOC)

# -------------------------------------------------------------
# Update git submodules
# -------------------------------------------------------------
if(NOT HELICS_DISABLE_GIT_OPERATIONS)
    include(updateGitSubmodules)
    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/fmtlib/CMakeLists.txt")
        submod_update(ThirdParty/fmtlib)
    endif()

    if(NOT HELICS_DISABLE_ASIO)
        if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/asio/asio/include/asio.hpp")
            submod_update(ThirdParty/asio)
        endif()
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/containers/gmlc/containers/BlockingQueue.hpp")
        submod_update(ThirdParty/containers)
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/concurrency/gmlc/concurrency/Barrier.hpp")
        submod_update(ThirdParty/concurrency)
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/utilities/gmlc/utilities/stringOps.h")
        submod_update(ThirdParty/utilities)
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/networking/gmlc/networking/TcpServer.h")
        submod_update(ThirdParty/networking)
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/units/units/units.hpp")
        submod_update(ThirdParty/units)
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/toml/include/toml11/value.hpp")
        submod_update(ThirdParty/toml)
    endif()

    if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/spdlog/CMakeLists.txt")
        submod_update(ThirdParty/spdlog)
    endif()

    set(IGNORE_MODULES libzmq)
    if(HELICS_BUILD_TESTS)
        if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/googletest/CMakeLists.txt")
            submod_update(ThirdParty/googletest)
        endif()
    else()
        list(APPEND IGNORE_MODULES googletest)
    endif()

    if(HELICS_BUILD_BENCHMARKS)
        if(NOT EXISTS "${PROJECT_SOURCE_DIR}/ThirdParty/benchmark/CMakeLists.txt")
            submod_update(ThirdParty/benchmark)
        endif()
    else()
        list(APPEND IGNORE_MODULES benchmark)
    endif()

    check_submodule_status(IGNORE_MODULES)

endif() # NOT HELICS_DISABLE_GIT_OPERATIONS
include(GNUInstallDirs)

# -------------------------------------------------------------
# BOOST  find the boost libraries
# -------------------------------------------------------------

if(NOT HELICS_DISABLE_BOOST)
    include(addBoost)
endif()

# -------------------------------------------------------------
# TOML11  add the TOML interpreter
# -------------------------------------------------------------
if(NOT TARGET toml11::toml11)
    set(toml11_BUILD_TEST OFF CACHE INTERNAL "")
    set(toml11_TEST_WITH_ASAN OFF CACHE INTERNAL "")
    set(toml11_TEST_WITH_UBSAN OFF CACHE INTERNAL "")
    set(toml11_INSTALL OFF CACHE INTERNAL "")

    if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.25)
        add_subdirectory(ThirdParty/toml EXCLUDE_FROM_ALL SYSTEM)
    else()
        add_subdirectory(ThirdParty/toml EXCLUDE_FROM_ALL)
    endif()
    hide_variable(TOML11_USE_UNRELEASED_TOML_FEATURES)
    hide_variable(TOML11_PRECOMPILE)
endif()

# -------------------------------------------------------------

=== requirements.txt ===
sphinx==8.1.2
sphinx_rtd_theme==3.0.2
myst-parser==4.0.1
ipython==8.32.0
ipykernel==6.29.5
breathe==4.35.0
sphinxcontrib-svg2pdfconverter==1.2.3
requests==2.32.3
gmlc-tdc-sphinxcontrib-redoc==1.6.1a1
sphinxcontrib-mermaid==1.0.0

=== CppInterface/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

add_executable(nonlings_fed1_cpp nonlings_fed1.cpp)
add_executable(nonlings_fed2_cpp nonlings_fed2.cpp)

target_link_libraries(nonlings_fed1_cpp PUBLIC helicsCpp98)
target_link_libraries(nonlings_fed2_cpp PUBLIC helicsCpp98)
target_link_libraries(nonlings_fed1_cpp PRIVATE compile_flags_target)
target_link_libraries(nonlings_fed2_cpp PRIVATE compile_flags_target)

set_property(TARGET nonlings_fed1_cpp PROPERTY CXX_STANDARD 98)
set_property(TARGET nonlings_fed2_cpp PROPERTY CXX_STANDARD 98)

if(!MSVC)
    target_compile_options(nonlings_fed1_cpp PRIVATE -pedantic -Werror)
    target_compile_options(nonlings_fed2_cpp PRIVATE -pedantic -Werror)
endif()

set_target_properties(nonlings_fed1_cpp nonlings_fed2_cpp PROPERTIES FOLDER examples)

if(HELICS_BUILD_TESTS AND NOT MSVC)
    add_test(NAME nonlings_example
             COMMAND ${PROJECT_SOURCE_DIR}/scripts/test_example.sh 10
                     $<TARGET_FILE:nonlings_fed1_cpp> $<TARGET_FILE:nonlings_fed2_cpp>
    )
    set_property(TEST nonlings_example PROPERTY LABELS Continuous)
endif()

=== helics/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

set(HELICS_BENCHMARKS
    ActionMessageBenchmarks
    filterBenchmarks
    echoBenchmarks
    ringBenchmarks
    messageLookupBenchmarks
    conversionBenchmarks
    echoMessageBenchmarks
    ringMessageBenchmarks
    messageSendBenchmarks
    pholdBenchmarks
    timingBenchmarks
    wattsStrogatzBenchmarks
    barabasiAlbertBenchmarks
)

if(HELICS_ENABLE_TCP_CORE)
    list(APPEND HELICS_BENCHMARKS TcpFederate)
endif()

set(HELICS_MULTINODE_BENCHMARKS
    PholdFederate
    MessageExchangeFederate
    RingTransmitFederate
    RingTransmitMessageFederate
    EchoHubFederate
    EchoLeafFederate
    EchoMessageHubFederate
    EchoMessageLeafFederate
    TimingHubFederate
    TimingLeafFederate
    WattsStrogatzFederate
    BarabasiAlbertFederate
)

if(NOT DEFINED HELICS_BENCHMARK_SHIFT_FACTOR)
    include(ProcessorCount)
    processorcount(N)
    if(N LESS 5)
        set(HELICS_BENCHMARK_SHIFT_FACTOR -1)
    else()
        set(HELICS_BENCHMARK_SHIFT_FACTOR 0)
    endif()
endif()

if(NOT HELICS_BENCHMARK_SHIFT_FACTOR GREATER -4)
    message(FATAL_ERROR "defined shift factor must be a number and greater than -4")
endif()

# Only affects current directory, so safe
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

foreach(T ${HELICS_BENCHMARKS})

    add_executable(${T} ${T}.cpp helics_benchmark_main.h helics_benchmark_util.h)
    target_link_libraries(${T} PUBLIC HELICS::application_api)
    add_benchmark(${T})
    set_target_properties(${T} PROPERTIES FOLDER benchmarks)
    target_compile_definitions(
        ${T} PRIVATE "HELICS_BENCHMARK_SHIFT_FACTOR=(${HELICS_BENCHMARK_SHIFT_FACTOR})"
    )
    install(TARGETS ${T} ${HELICS_EXPORT_COMMAND} DESTINATION ${CMAKE_INSTALL_BINDIR}
            COMPONENT benchmarks
    )
endforeach()

add_executable(helics_benchmarks BenchmarkMain.cpp BenchmarkFederate.hpp)
target_link_libraries(helics_benchmarks PUBLIC HELICS::application_api)
set_target_properties(helics_benchmarks PROPERTIES FOLDER benchmarks_multimachine)
foreach(T ${HELICS_MULTINODE_BENCHMARKS})
    target_sources(helics_benchmarks PRIVATE ${T}.hpp)
endforeach()
install(TARGETS helics_benchmarks ${HELICS_EXPORT_COMMAND} DESTINATION ${CMAKE_INSTALL_BINDIR}
        COMPONENT benchmarks
)

if(NOT HELICS_DISABLE_C_SHARED_LIB)
    add_executable(echoBenchmarks_c echoBenchmarks_c.cpp)
    target_link_libraries(echoBenchmarks_c PUBLIC helics)
    add_benchmark(echoBenchmarks_c)
    set_target_properties(echoBenchmarks_c PROPERTIES FOLDER benchmarks)
    target_compile_definitions(
        echoBenchmarks_c PRIVATE "HELICS_BENCHMARK_SHIFT_FACTOR=(${HELICS_BENCHMARK_SHIFT_FACTOR})"
    )
    target_include_directories(echoBenchmarks_c PRIVATE ${HELICS_SOURCE_DIR}/ThirdParty)
    target_include_directories(echoBenchmarks_c PRIVATE ${HELICS_SOURCE_DIR}/src)
    install(TARGETS echoBenchmarks_c ${HELICS_EXPORT_COMMAND} DESTINATION ${CMAKE_INSTALL_BINDIR}
            COMPONENT benchmarks
    )
endif()

string(TIMESTAMP current_date "%Y-%m-%d")
string(RANDOM rname)

set(BM_RESULT_DIR)
set(BM_FORMAT --benchmark_format=json)
if(NOT HELICS_DISABLE_C_SHARED_LIB)
    set(HELICS_ECHO_C_COMMANDS COMMAND echoBenchmarks_c ${BM_FORMAT}
                               ">${BM_RESULT_DIR}bm_echo_cResults${current_date}_${rname}.txt"
    )
endif()
# add a custom target to run all the benchmarks in a consistent fashion
add_custom_target(
    RUN_ALL_BENCHMARKS
    COMMAND ${CMAKE_COMMAND} -E echo " running ActionMessageBenchmarks"
    COMMAND ActionMessageBenchmarks ${BM_FORMAT}
            ">${BM_RESULT_DIR}bm_ActionMessageResults${current_date}_${rname}.txt"
    COMMAND ${CMAKE_COMMAND} -E echo " running conversionBenchmarks"
    COMMAND conversionBenchmarks ${BM_FORMAT}
            ">${BM_RESULT_DIR}bm_conversionResults${current_date}_${rname}.txt"
    COMMAND ${CMAKE_COMMAND} -E echo " running echoBenchmarks"
    COMMAND echoBenchmarks ${BM_FORMAT}
            ">${BM_RESULT_DIR}bm_echoResults${current_date}_${rname}.txt"
    COMMAND ${CMAKE_COMMAND} -E echo " running echoBenchmarks_c" ${HELICS_ECHO_C_COMMANDS}
    COMMAND ${CMAKE_COMMAND} -E echo " running ringBenchmarks"
    COMMAND ringBenchmarks ${BM_FORMAT}
            ">${BM_RESULT_DIR}bm_ringResults${current_date}_${rname}.txt"
    COMMAND ${CMAKE_COMMAND} -E echo " running ringMessageBenchmarks"
    COMMAND ringMessageBenchmarks ${BM_FORMAT}
            ">${BM_RESULT_DIR}bm_ringMessageResults${current_date}_${rname}.txt"
    COMMAND ${CMAKE_COMMAND} -E echo " running messageLookupBenchmarks"
    COMMAND messageLookupBenchmarks ${BM_FORMAT}
            ">${BM_RESULT_DIR}bm_messageLookupResults${current_date}_${rname}.txt"
    COMMAND ${CMAKE_COMMAND} -E echo " running echoMessageBenchmarks"
    COMMAND echoMessageBenchmarks ${BM_FORMAT}
            ">${BM_RESULT_DIR}bm_echoMessageResults${current_date}_${rname}.txt"
    COMMAND ${CMAKE_COMMAND} -E echo " running timingBenchmarks"
    COMMAND timingBenchmarks ${BM_FORMAT}
            ">${BM_RESULT_DIR}bm_timingResults${current_date}_${rname}.txt"
    COMMAND ${CMAKE_COMMAND} -E echo " running filterBenchmarks"
    COMMAND filterBenchmarks ${BM_FORMAT}
            ">${BM_RESULT_DIR}bm_filterResults${current_date}_${rname}.txt"
    COMMAND ${CMAKE_COMMAND} -E echo " running pHoldBenchmarks"
    COMMAND pholdBenchmarks ${BM_FORMAT}
            ">${BM_RESULT_DIR}bm_pholdResults${current_date}_${rname}.txt"
    COMMAND ${CMAKE_COMMAND} -E echo " running messageSendBenchmarks"
    COMMAND messageSendBenchmarks ${BM_FORMAT}
            ">${BM_RESULT_DIR}bm_messageSendResults${current_date}_${rname}.txt"
)

foreach(T ${HELICS_BENCHMARKS})
    add_dependencies(RUN_ALL_BENCHMARKS ${T})
endforeach()

if(NOT HELICS_DISABLE_C_SHARED_LIB)
    add_dependencies(RUN_ALL_BENCHMARKS echoBenchmarks_c)
endif()

set_target_properties(RUN_ALL_BENCHMARKS PROPERTIES FOLDER benchmarks)

add_custom_target(
    RUN_KEY_BENCHMARKS
    COMMAND ${CMAKE_COMMAND} -E echo " running conversionBenchmarks"
    COMMAND conversionBenchmarks --benchmark_format=json
            ">${BM_RESULT_DIR}bmk_conversionResults${current_date}_${rname}.txt"
    COMMAND ${CMAKE_COMMAND} -E echo " running echoBenchmarks with filter=/4"
    COMMAND echoBenchmarks --benchmark_format=json --benchmark_filter=/4
            ">${BM_RESULT_DIR}bmk_echoResults${current_date}_${rname}.txt"
    COMMAND ${CMAKE_COMMAND} -E echo " running timingoBenchmarks with filter=/4"
    COMMAND timingBenchmarks --benchmark_format=json --benchmark_filter=/4
            ">${BM_RESULT_DIR}bmk_timingResults${current_date}_${rname}.txt"
    COMMAND ${CMAKE_COMMAND} -E echo
            " running messageLookupBenchmarks with filter=/[0-9][0-9][0-9][0-9]/"
    COMMAND
        messageLookupBenchmarks --benchmark_format=json --benchmark_filter=/[0-9][0-9][0-9][0-9]/
        ">${BM_RESULT_DIR}bmk_messageLookupResults${current_date}_${rname}.txt"
    COMMAND ${CMAKE_COMMAND} -E echo " running echoMessageBenchmarks with filter=/4"
    COMMAND echoMessageBenchmarks --benchmark_format=json --benchmark_filter=/4
            ">${BM_RESULT_DIR}bmk_echoMessageResults${current_date}_${rname}.txt"
)

foreach(T ${HELICS_BENCHMARKS})
    add_dependencies(RUN_KEY_BENCHMARKS ${T})
endforeach()

set_target_properties(RUN_KEY_BENCHMARKS PROPERTIES FOLDER benchmarks)

=== java/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

find_package(Java REQUIRED)
find_package(JNI REQUIRED)
include(UseJava)

set(helicsJar ${CMAKE_BINARY_DIR}/interfaces/java/jarproject/buildjar/helics-${HELICS_VERSION}.jar)

add_custom_target(
    Java_hello_world ALL
    ${Java_JAVAC_EXECUTABLE}
    -classpath
    ${CMAKE_BINARY_DIR}/interfaces/java/jarproject/buildjar/helics-${HELICS_VERSION}.jar
    -d
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/HelloWorld.java
    DEPENDS helics::java
            ${CMAKE_BINARY_DIR}/interfaces/java/jarproject/buildjar/helics-${HELICS_VERSION}.jar
    COMMENT "Building HelloWorld.java"
    VERBATIM
)

add_custom_target(
    Java_Helics_Api ALL
    ${Java_JAVAC_EXECUTABLE}
    -classpath
    ${CMAKE_BINARY_DIR}/interfaces/java/jarproject/buildjar/helics-${HELICS_VERSION}.jar
    -d
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/JavaHelicsApiTests.java
    DEPENDS helics::java
            ${CMAKE_BINARY_DIR}/interfaces/java/jarproject/buildjar/helics-${HELICS_VERSION}.jar
    COMMENT "Building JavaHelicsApiTests.java"
    VERBATIM
)

# Windows uses a different separator for Java classpaths than other platforms
if(CMAKE_HOST_WIN32 AND NOT CYGWIN AND CMAKE_HOST_SYSTEM_NAME MATCHES "Windows")
    set(CMAKE_JAVA_INCLUDE_FLAG_SEP ";")
else()
    set(CMAKE_JAVA_INCLUDE_FLAG_SEP ":")
endif()
set(java_test_classpath
    "${helicsJar}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${CMAKE_CURRENT_BINARY_DIR}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
)

add_test(NAME Java_hello_world_test
         COMMAND ${Java_JAVA_EXECUTABLE} -Djava.library.path=$<TARGET_FILE_DIR:helics::java>
                 -classpath "${java_test_classpath}" HelloWorld
)

add_test(NAME Java_Helics_Api_tests
         COMMAND ${Java_JAVA_EXECUTABLE} -Djava.library.path=$<TARGET_FILE_DIR:helics::java>
                 -classpath "${java_test_classpath}" JavaHelicsApiTests
)

add_custom_target(
    RUN_JAVA_TEST
    COMMAND ${Java_JAVA_EXECUTABLE} -Djava.library.path=$<TARGET_FILE_DIR:helics::java> -classpath
            "${java_test_classpath}" JavaHelicsApiTests DEPENDS Java_Helics_Api
)

set_target_properties(Java_hello_world Java_Helics_Api RUN_JAVA_TEST PROPERTIES FOLDER tests)

set_property(TEST Java_hello_world_test Java_Helics_Api_tests PROPERTY LABELS Java Continuous Daily)

=== toml/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# project_source_dir has not been set yet
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/include/toml11/version.hpp" TOML11_MAJOR_VERSION_STRING
    REGEX "#define TOML11_VERSION_MAJOR ([0-9]+)")
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/include/toml11/version.hpp" TOML11_MINOR_VERSION_STRING
    REGEX "#define TOML11_VERSION_MINOR ([0-9]+)")
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/include/toml11/version.hpp" TOML11_PATCH_VERSION_STRING
    REGEX "#define TOML11_VERSION_PATCH ([0-9]+)")

string(REGEX REPLACE "#define TOML11_VERSION_MAJOR ([0-9]+)" "\\1" TOML11_VERSION_MAJOR "${TOML11_MAJOR_VERSION_STRING}")
string(REGEX REPLACE "#define TOML11_VERSION_MINOR ([0-9]+)" "\\1" TOML11_VERSION_MINOR "${TOML11_MINOR_VERSION_STRING}")
string(REGEX REPLACE "#define TOML11_VERSION_PATCH ([0-9]+)" "\\1" TOML11_VERSION_PATCH "${TOML11_PATCH_VERSION_STRING}")

project(toml11 LANGUAGES CXX VERSION "${TOML11_VERSION_MAJOR}.${TOML11_VERSION_MINOR}.${TOML11_VERSION_PATCH}")

include(CTest) # to use ${BUILD_TESTING}

option(TOML11_PRECOMPILE "precompile toml11 library" OFF)

include(CMakeDependentOption)
cmake_policy(PUSH)
if(POLICY CMP0127)
cmake_policy(SET CMP0127 OLD) # syntax of condition changed in 3.22
endif()
cmake_dependent_option(TOML11_INSTALL "install toml11 library" ON
    "${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}" OFF)
cmake_dependent_option(TOML11_BUILD_EXAMPLES "build toml11 examples" OFF
    "${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}" OFF)
cmake_dependent_option(TOML11_BUILD_TESTS "build toml11 unit tests" OFF
    "${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}; ${BUILD_TESTING}" OFF)
cmake_dependent_option(TOML11_BUILD_TOML_TESTS "build toml11 toml-test encoder & decoder" OFF
    "${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME}" OFF)
cmake_policy(POP)

cmake_dependent_option(TOML11_TEST_WITH_ASAN  "build toml11 unit tests with asan" OFF
    "${TOML11_BUILD_TESTS}" OFF)
cmake_dependent_option(TOML11_TEST_WITH_UBSAN "build toml11 unit tests with ubsan" OFF
    "${TOML11_BUILD_TESTS}" OFF)

if(${TOML11_TEST_WITH_ASAN} AND ${TOML11_TEST_WITH_UBSAN})
    message(FATAL_ERROR "trying to build tests with BOTH asan and ubsan")
endif()

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag("-Wall"                 TOML11_COMPILER_SUPPORTS_WALL)
check_cxx_compiler_flag("-Wextra"               TOML11_COMPILER_SUPPORTS_WEXTRA)
check_cxx_compiler_flag("-Wpedantic"            TOML11_COMPILER_SUPPORTS_WPEDANTIC)
check_cxx_compiler_flag("-Werror"               TOML11_COMPILER_SUPPORTS_WERROR)
check_cxx_compiler_flag("-Wsign-conversion"     TOML11_COMPILER_SUPPORTS_WSIGN_CONVERSION)
check_cxx_compiler_flag("-Wconversion"          TOML11_COMPILER_SUPPORTS_WCONVERSION)
check_cxx_compiler_flag("-Wduplicated-cond"     TOML11_COMPILER_SUPPORTS_WDUPLICATED_COND)
check_cxx_compiler_flag("-Wduplicated-branches" TOML11_COMPILER_SUPPORTS_WDUPLICATED_BRANCHES)
check_cxx_compiler_flag("-Wlogical-op"          TOML11_COMPILER_SUPPORTS_WLOGICAL_OP)
check_cxx_compiler_flag("-Wdouble-promotion"    TOML11_COMPILER_SUPPORTS_WDOUBLE_PROMOTION)
check_cxx_compiler_flag("-Wrange-loop-analysis" TOML11_COMPILER_SUPPORTS_WRANGE_LOOP_ANALYSIS)
check_cxx_compiler_flag("-Wundef"               TOML11_COMPILER_SUPPORTS_WUNDEF)
check_cxx_compiler_flag("-Wshadow"              TOML11_COMPILER_SUPPORTS_WSHADOW)

include(GNUInstallDirs)
set(TOML11_INSTALL_CMAKE_DIR   ${CMAKE_INSTALL_LIBDIR}/cmake/toml11)
set(TOML11_INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_INCLUDEDIR})
set(TOML11_CONFIG_DIR          ${CMAKE_CURRENT_BINARY_DIR}/cmake)
set(TOML11_CONFIG              ${TOML11_CONFIG_DIR}/toml11Config.cmake)
set(TOML11_CONFIG_VERSION      ${TOML11_CONFIG_DIR}/toml11ConfigVersion.cmake)

# root project?
if(${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME})
    if(NOT DEFINED CMAKE_CXX_STANDARD)
        set(CMAKE_CXX_STANDARD 11)
    endif()
    if(NOT DEFINED CMAKE_CXX_EXTENSIONS)
        set(CMAKE_CXX_EXTENSIONS OFF)
    endif()
    if(NOT DEFINED CMAKE_CXX_STANDARD_REQUIRED)
        set(CMAKE_CXX_STANDARD_REQUIRED ON)
    endif()

    if(${TOML11_BUILD_TESTS} OR ${TOML11_BUILD_TOML_TESTS})
        add_subdirectory(tests)
    endif()

    if(${TOML11_BUILD_EXAMPLES})
        add_subdirectory(examples)
    endif()
endif()

add_subdirectory(src)

=== helics/apps/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

if(HELICS_BUILD_APP_LIBRARY)

    cmake_dependent_advanced_option(
        HELICS_DISABLE_WEBSERVER
        "Disable the embedded webserver app structure in the broker server" OFF
        "NOT HELICS_DISABLE_BOOST" ON
    )
    set(helics_apps_public_headers
        Player.hpp
        Recorder.hpp
        Echo.hpp
        Source.hpp
        Tracer.hpp
        helicsApp.hpp
        Clone.hpp
        CoreApp.hpp
        Probe.hpp
        Connector.hpp
        BrokerApp.hpp
    )

    set(helics_apps_broker_headers MultiBroker.hpp BrokerServer.hpp zmqBrokerServer.hpp
                                   AsioBrokerServer.hpp TypedBrokerServer.hpp
    )

    set(helics_apps_private_headers PrecHelper.hpp SignalGenerators.hpp)

    set(helics_apps_library_files
        Player.cpp
        Recorder.cpp
        PrecHelper.cpp
        SignalGenerators.cpp
        Echo.cpp
        Source.cpp
        Tracer.cpp
        helicsApp.cpp
        Clone.cpp
        Probe.cpp
        Connector.cpp
    )

    set(helics_apps_broker_files MultiBroker.cpp BrokerServer.cpp zmqBrokerServer.cpp
                                 TypedBrokerServer.cpp
    )

    if(NOT HELICS_DISABLE_ASIO)
        list(APPEND helics_apps_broker_files AsioBrokerServer.cpp)
    endif()

    if(NOT (HELICS_DISABLE_WEBSERVER OR HELICS_DISABLE_BOOST OR HELICS_DISABLE_ASIO))
        message(STATUS "Building webserver Boost version ${Boost_VERSION} ${BOOST_VERSION_LEVEL}")
        list(APPEND helics_apps_broker_files helicsWebServer.cpp RestApiConnection.cpp)
        list(APPEND helics_apps_broker_headers helicsWebServer.hpp indexPage.hpp
             RestApiConnection.hpp
        )
    endif()

    add_library(
        helics_apps STATIC
        ../helics_apps.hpp
        ${helics_apps_library_files}
        ${helics_apps_public_headers}
        ${helics_apps_broker_headers}
        ${helics_apps_private_headers}
        ${helics_apps_broker_files}
    )

    target_link_libraries(helics_apps PUBLIC HELICS::application_api)
    target_link_libraries(
        helics_apps
        PRIVATE HELICS::compile_flags_target
                spdlog::spdlog
                fmt::fmt
                helics::zmq
                HELICS::common
                gmlc::networking
    )

    if(NOT (HELICS_DISABLE_WEBSERVER OR HELICS_DISABLE_BOOST OR HELICS_DISABLE_ASIO))
        target_compile_definitions(helics_apps PUBLIC BOOST_DATE_TIME_NO_LIB)
        if(${Boost_VERSION_MINOR} LESS 81)
            target_compile_definitions(helics_apps PUBLIC BOOST_BEAST_USE_STD_STRING_VIEW)
        endif()
        target_compile_definitions(helics_apps PUBLIC HELICS_ENABLE_WEBSERVER=1)
        if(WIN32)
            target_link_libraries(helics_apps PRIVATE bcrypt)
        endif()

        if(MSVC)
            target_compile_options(helics_apps PRIVATE "/bigobj")
        endif()
    endif()
    # add and alias library to match the find_package
    add_library(HELICS::apps ALIAS helics_apps)

    if(HELICS_BUILD_APP_EXECUTABLES)
        add_executable(helics_player playerMain.cpp)
        target_link_libraries(helics_player PUBLIC HELICS::apps)
        target_link_libraries(helics_player PRIVATE compile_flags_target)
        set_target_properties(helics_player PROPERTIES FOLDER apps)
        install(TARGETS helics_player ${HELICS_EXPORT_COMMAND} DESTINATION ${CMAKE_INSTALL_BINDIR}
                COMPONENT applications
        )

        add_executable(helics_recorder recorderMain.cpp)
        target_link_libraries(helics_recorder PUBLIC HELICS::apps)
        set_target_properties(helics_recorder PROPERTIES FOLDER apps)
        target_link_libraries(helics_recorder PRIVATE compile_flags_target)
        install(TARGETS helics_recorder ${HELICS_EXPORT_COMMAND} DESTINATION ${CMAKE_INSTALL_BINDIR}
                COMPONENT applications
        )

        add_executable(helics_connector connectorMain.cpp)
        target_link_libraries(helics_connector PUBLIC HELICS::apps)
        target_link_libraries(helics_connector PRIVATE compile_flags_target)
        set_target_properties(helics_connector PROPERTIES FOLDER apps)
        install(TARGETS helics_connector ${HELICS_EXPORT_COMMAND}
                DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT applications
        )

        add_executable(helics_broker helics-broker.cpp)
        target_link_libraries(helics_broker PUBLIC HELICS::apps)
        target_link_libraries(helics_broker PRIVATE compile_flags_target)
        set_target_properties(helics_broker PROPERTIES FOLDER apps)
        set(HELICS_BROKER_LOC ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
            CACHE INTERNAL "build folder location of the broker"
        )

        add_test(NAME broker_version_return COMMAND helics_broker --version)
        add_test(NAME broker_help_return COMMAND helics_broker --help)
        set_property(TEST broker_version_return broker_help_return PROPERTY LABELS Continuous)

        add_executable(helics_broker_server helics-broker-server.cpp)
        target_link_libraries(helics_broker_server PUBLIC HELICS::apps)
        target_link_libraries(helics_broker_server PRIVATE compile_flags_target)
        set_target_properties(helics_broker_server PROPERTIES FOLDER apps)
        set(HELICS_BROKER_SERVER_LOC ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
            CACHE INTERNAL "build folder location of the broker server"
        )
        install(TARGETS helics_broker helics_broker_server ${HELICS_EXPORT_COMMAND}
                DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT applications
        )

        add_executable(helics_app appMain.cpp)
        target_link_libraries(helics_app PUBLIC HELICS::apps)
        target_link_libraries(helics_app PRIVATE spdlog::spdlog compile_flags_target)
        set_target_properties(helics_app PROPERTIES FOLDER apps)
        install(TARGETS helics_app ${HELICS_EXPORT_COMMAND} DESTINATION ${CMAKE_INSTALL_BINDIR}
                COMPONENT applications
        )

        add_test(NAME app_version_return COMMAND helics_app --version)
        add_test(NAME app_help_return COMMAND helics_app --help)
        set_property(TEST app_version_return app_help_return PROPERTY LABELS Continuous)

        add_test(NAME app_subcommand_version_return COMMAND helics_app player --version)
        add_test(NAME app_subcommand_help_return COMMAND helics_app player --help)
        set_property(
            TEST app_subcommand_version_return app_subcommand_help_return PROPERTY LABELS
                                                                                   Continuous
        )
    endif(HELICS_BUILD_APP_EXECUTABLES)

    if(HELICS_BUILD_CXX_SHARED_LIB)
        add_library(
            helicscpp-apps SHARED ../helics_apps.hpp ${helics_apps_library_files}
                                  ${helics_apps_public_headers} ${helics_apps_private_headers}
        )

        target_link_libraries(helicscpp-apps PUBLIC HELICS::helicscpp)
        target_link_libraries(
            helicscpp-apps PRIVATE HELICS::common spdlog::spdlog fmt::fmt gmlc::utilities
                                   gmlc::networking
        )

        # add and alias library to match the find_package
        add_library(HELICS::helicscpp-apps ALIAS helicscpp-apps)

        target_compile_definitions(helicscpp-apps PRIVATE helicscpp_EXPORTS)

        target_include_directories(
            helicscpp-apps
            INTERFACE $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include/helics_cxx>
                      $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>
            PRIVATE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        )

        target_include_directories(
            helicscpp-apps SYSTEM INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/ThirdParty>
        )

        set_target_properties(
            helicscpp-apps PROPERTIES VERSION ${HELICS_VERSION} SOVERSION ${HELICS_VERSION_MAJOR}
        )

        set_target_properties(
            helicscpp-apps PROPERTIES CXX_VISIBILITY_PRESET hidden C_VISIBILITY_PRESET hidden
                                      VISIBILITY_INLINES_HIDDEN ON
        )

        install(
            TARGETS helicscpp-apps ${HELICS_EXPORT_COMMAND}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        )

        if(WIN32)
            install(FILES $<TARGET_LINKER_FILE:helicscpp-apps> DESTINATION ${CMAKE_INSTALL_LIBDIR}
                    COMPONENT libs
            )
            install(FILES $<TARGET_FILE:helicscpp-apps> DESTINATION ${CMAKE_INSTALL_BINDIR}
                    COMPONENT Runtime
            )
        else()
            install(TARGETS helicscpp-apps DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RUNTIME)
        endif()

        if(NOT HELICS_BINARY_ONLY_INSTALL)

            if(MSVC AND NOT HELICS_EMBEDDED_DEBUG_INFO)
                install(
                    FILES $<TARGET_PDB_FILE:helicscpp-apps>
                    DESTINATION ${CMAKE_INSTALL_BINDIR}
                    OPTIONAL
                    COMPONENT libs
                )
            endif()

        endif()
    endif()

endif(HELICS_BUILD_APP_LIBRARY)

=== helics/cpp98/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

set(helicsCpp98_headers
    Broker.hpp
    Core.hpp
    CombinationFederate.hpp
    Federate.hpp
    MessageFederate.hpp
    helicsExceptions.hpp
    ValueFederate.hpp
    helics.hpp
    Publication.hpp
    Input.hpp
    Endpoint.hpp
    DataBuffer.hpp
    Filter.hpp
    Translator.hpp
    config.hpp
)

add_library(helicsCpp98 INTERFACE)
target_link_libraries(helicsCpp98 INTERFACE helics)
add_library(HELICS::helicsCpp98 ALIAS helicsCpp98)
target_include_directories(
    helicsCpp98 INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
                          $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>
)

# this is purely so the files show up nicely in an IDE, other ides might use it as well but that can
# be added when/if the need arises
if(MSVC)
    add_library(helicsCpp98_ide STATIC ${helicsCpp98_headers} ../../empty.cpp)
    target_include_directories(helicsCpp98_ide PRIVATE "${PROJECT_SOURCE_DIR}/src/helics")
    target_include_directories(
        helicsCpp98_ide PRIVATE "${PROJECT_BINARY_DIR}/src/helics/shared_api_library"
    )
    set_target_properties(helicsCpp98_ide PROPERTIES FOLDER interfaces)
endif(MSVC)

install(
    TARGETS helicsCpp98 ${HELICS_EXPORT_COMMAND}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES ${helicsCpp98_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/helics/cpp98
        COMPONENT headers
)

=== helics/sequencing_tests/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

set(sequencing_test_sources
    Sequencing1.cpp
    Sequencing2.cpp
    sequencing-tests.cpp
    sequencingHelpers.hpp
    sequencingHelpers.cpp
    ../application_api/testFixtures.cpp
    ../application_api/testFixtures.hpp
    ../coreTypeLists.hpp
)

add_executable(sequencing-tests ${sequencing_test_sources})
target_link_libraries(sequencing-tests helics_application_api helics_test_base gmock)

set_target_properties(sequencing-tests PROPERTIES FOLDER tests)

target_compile_definitions(
    sequencing-tests PRIVATE "-DHELICS_BROKER_LOCATION=\"${HELICS_BROKER_LOC}\""
)
target_compile_definitions(
    sequencing-tests PRIVATE "-DHELICS_INSTALL_LOCATION=\"${CMAKE_INSTALL_PREFIX}\""
)
target_compile_definitions(
    sequencing-tests PRIVATE "-DTEST_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/../test_files/\""
)

# add_test(NAME application-api-tests COMMAND application-api-tests) set_property(TEST
# application-api-tests PROPERTY LABELS ApplicationApi Coverage Daily)

# Tests for Continuous Integration builds add_test(NAME application-api-ci-tests COMMAND
# application-api-tests --gtest_filter=-*ci_skip*) set_property(TEST application-api-ci-tests
# PROPERTY LABELS ApplicationApiCI Continuous)

=== helics/shared_api_library/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

set(helicsShared_headers
    helicsCore.h
    helicsData.h
    api-data.h
    ValueFederate.h
    MessageFederate.h
    MessageFilters.h
    Translators.h
    helicsCallbacks.h
    helicsApps.h
)

set(helicsShared_sources
    helicsExport.cpp
    FederateExport.cpp
    ValueFederateExport.cpp
    MessageFederateExport.cpp
    MessageFiltersExport.cpp
    TranslatorExport.cpp
    helicsCallbacks.cpp
    helicsData.cpp
    internal/api_objects.h
)

if(TARGET HELICS::apps)
    list(APPEND helicsShared_sources helicsAppsExport.cpp)
else()
    list(APPEND helicsShared_sources helicsAppsExportNull.cpp)
endif()

include(GenerateExportHeader)

if(Python_EXECUTABLE)
    add_custom_command(
        OUTPUT ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h
               ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics_api.h
        COMMAND ${Python_EXECUTABLE} ARGS ${PROJECT_SOURCE_DIR}/scripts/generateHelicsH.py
                ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/ ${PROJECT_SOURCE_DIR}
        DEPENDS helicsCore.h
                helicsCallbacks.h
                MessageFederate.h
                ValueFederate.h
                MessageFilters.h
                Translators.h
                helicsData.h
                helicsCore.h
                helicsApps.h
                Translators.h
                api-data.h
                ../helics_enums.h
    )

    # this section is for developer convenience to make sure the backup files get copied over when
    # working on the C API
    if(HELICS_OVERWRITE_BACKUP_H_FILES)
        add_custom_target(
            overwrite_backup_files ALL
            DEPENDS ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h
                    ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics_api.h
        )
        add_custom_command(
            TARGET overwrite_backup_files
            POST_BUILD
            COMMAND
                ${CMAKE_COMMAND} -E copy
                ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h
                ${PROJECT_SOURCE_DIR}/src/helics/shared_api_library/backup/helics DEPENDS
                ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h
        )
        add_custom_command(
            TARGET overwrite_backup_files
            POST_BUILD
            COMMAND
                ${CMAKE_COMMAND} -E copy
                ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics_api.h
                ${PROJECT_SOURCE_DIR}/src/helics/shared_api_library/backup/helics DEPENDS
                ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics_api.h
        )

        set_target_properties(overwrite_backup_files PROPERTIES FOLDER interfaces)
    endif()
else()
    configure_file(
        ${PROJECT_SOURCE_DIR}/src/helics/shared_api_library/backup/helics/helics.h
        ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h COPYONLY
    )
    configure_file(
        ${PROJECT_SOURCE_DIR}/src/helics/shared_api_library/backup/helics/helics_api.h
        ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics_api.h COPYONLY
    )
endif()

add_library(
    helics SHARED ${helicsShared_sources} ${helicsShared_headers}
                  ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h
)

add_library(HELICS::helics ALIAS helics)
generate_export_header(helics BASE_NAME helics)

target_include_directories(
    helics PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    INTERFACE $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/helics_generated_includes>
              $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>
)

set_target_properties(helics PROPERTIES VERSION ${HELICS_VERSION} SOVERSION ${HELICS_VERSION_MAJOR})

set_target_properties(helics PROPERTIES CXX_VISIBILITY_PRESET hidden C_VISIBILITY_PRESET hidden)
target_link_libraries(helics PRIVATE helics_application_api)
if(TARGET HELICS::apps)
    target_link_libraries(helics PRIVATE HELICS::apps)
endif()
target_link_libraries(helics PRIVATE compile_flags_target)

if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_compile_options(helics PUBLIC -Wno-documentation)
endif()

if(UNIX OR MINGW)
    if(NOT APPLE)
        include(CheckLinkerFlag)
        check_linker_flag(
            CXX "-Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/export.txt"
            flag_linker_version_script
        )
        if(flag_linker_version_script)
            target_link_libraries(
                helics PRIVATE -Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/export.txt
            )
        endif()
        check_linker_flag(CXX "-Wl,--exclude-libs,ALL" flag_linker_exclude_libs)
        if(flag_linker_exclude_libs)
            target_link_libraries(helics PRIVATE -Wl,--exclude-libs,ALL)
        endif()
    else(NOT_APPLE)
        include(CheckLinkerFlag)
        check_linker_flag(
            CXX "-Wl,-exported_symbols_list,${CMAKE_CURRENT_SOURCE_DIR}/export_mac.txt"
            flag_linker_exported_symbols_list
        )
        if(flag_linker_exported_symbols_list)
            target_link_libraries(
                helics
                PRIVATE -Wl,-exported_symbols_list,${CMAKE_CURRENT_SOURCE_DIR}/export_mac.txt
            )
        endif()
    endif(NOT APPLE)
endif()

set_target_properties(helics PROPERTIES FOLDER interfaces)

install(
    TARGETS helics ${HELICS_EXPORT_COMMAND}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

if(WIN32)
    install(
        FILES $<TARGET_LINKER_FILE:helics>
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT libs
        EXCLUDE_FROM_ALL
    )
    install(
        FILES $<TARGET_FILE:helics>
        DESTINATION ${CMAKE_INSTALL_BINDIR}
        COMPONENT Runtime
        EXCLUDE_FROM_ALL
    )
else()
    install(
        TARGETS helics
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT RUNTIME
        EXCLUDE_FROM_ALL
    )
endif()

if(MSVC AND NOT HELICS_EMBEDDED_DEBUG_INFO)
    install(
        FILES $<TARGET_PDB_FILE:helics>
        DESTINATION ${CMAKE_INSTALL_BINDIR}
        OPTIONAL
        COMPONENT libs
    )
endif()

if(NOT HELICS_BINARY_ONLY_INSTALL)
    install(FILES ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics.h
                  ${PROJECT_BINARY_DIR}/helics_generated_includes/helics/helics_api.h
            DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/helics COMPONENT headers
    )

    install(FILES ../helics98.hpp DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/helics COMPONENT headers)
endif()

=== helics/system_tests/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2017-2025, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

set(system_test_sources
    helics_system_tests.cpp
    TimingTests.cpp
    iterationTests.cpp
    ErrorTests.cpp
    TimingTests2.cpp
    QueryTests.cpp
    heat-transfer-tests.cpp
    flagTests.cpp
    updateTests.cpp
    networkTests.cpp
    commandInterfaceTests.cpp
    profilingTests.cpp
    dynamicFederationTests.cpp
    messageSizeTests.cpp
    ../application_api/testFixtures.cpp
    ../application_api/testFixtures.hpp
    ../apps/exeTestHelper.cpp
    ../apps/exeTestHelper.h
)

if(NOT HELICS_DISABLE_ASIO)
    list(APPEND system_test_sources federateRealTimeTests.cpp brokerTimeoutTests.cpp)
endif()

add_executable(system-tests ${system_test_sources} ${system_test_headers})
target_link_libraries(system-tests helics_application_api helics_test_base)

set_target_properties(system-tests PROPERTIES FOLDER tests)

target_compile_definitions(system-tests PRIVATE "-DHELICS_BROKER_LOCATION=\"${HELICS_BROKER_LOC}\"")
target_compile_definitions(
    system-tests PRIVATE "-DHELICS_INSTALL_LOCATION=\"${CMAKE_INSTALL_PREFIX}\""
)
target_compile_definitions(system-tests PRIVATE "-DTEST_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}\"")
target_compile_definitions(
    system-tests PRIVATE "-DTEST_BIN_DIR=\"${CMAKE_CURRENT_BINARY_DIR}/../test_files/\""
)

add_test(NAME system-tests COMMAND system-tests)
set_property(TEST system-tests PROPERTY LABELS System Coverage Daily TSAN)

# Tests for Continuous Integration builds
add_test(NAME system-ci-tests COMMAND system-tests --gtest_filter=-*ci_skip*:*nosan*)
set_property(TEST system-ci-tests PROPERTY LABELS SystemCI Continuous Valgrind)

=== networking/ThirdParty/NetIF/tests/CMakeLists.txt ===
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Copyright (c) 2019, Battelle Memorial Institute; Lawrence Livermore
# National Security, LLC; Alliance for Sustainable Energy, LLC.
# See the top-level NOTICE for additional details.
# All rights reserved.
#
# SPDX-License-Identifier: BSD-3-Clause
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

add_executable(GetAddressTests GetAddressTests.cpp)
target_link_libraries(GetAddressTests NetIF::NetIF)

add_test(GetAddressTests GetAddressTests)

=== PKGBUILD ===
# Maintainer: Philip Top <top1@llnl.gov>

_realname=helics
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=3.6.1
pkgrel=2
pkgdesc="Hierarchical Engine for Large-scale Infrastructure Co-Simulation (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/GMLC-TDC/HELICS"
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-zeromq"
         "${MINGW_PACKAGE_PREFIX}-fmt")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost")
options=('!strip')
source=("https://github.com/GMLC-TDC/HELICS/releases/download/v${pkgver}/HELICS-v${pkgver}-source.tar.gz"
        "001-aarch64-processor-name.patch")
sha256sums=('d607c1b47dd5ae32f3076c4aa4aa584d37b6056a9bd049234494698ed95cd70f'
            '5853683dc368453155bf690fb9082b98e88da5d854de8f2da8f32830996f0013')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"

  apply_patch_with_msg \
    001-aarch64-processor-name.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_CXX_STANDARD=20 \
    -DBUILD_SHARED_LIBS=ON \
    -DHELICS_ENABLE_IPC_CORE=OFF \
    -DHELICS_DISABLE_GIT_OPERATIONS=ON \
    -DHELICS_DISABLE_VCPKG=ON \
    -DHELICS_DISABLE_ASIO=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "OFF" || echo "ON") \
    -DHELICS_USE_EXTERNAL_FMT=ON \
    ${extra_config} \
    ..

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .
  rm -f "${pkgdir}"${MINGW_PREFIX}/bin/libzmq.dll.a
}
